<?php
/**
 * Mod Name: Thread Description
 * Copyright  2008 kastun
 *
 * Author: kastun
 * Version 1.1
 */
 
/** 
* Polish Language File developed by mybboard.pl for Thread Description 1.1
* Tumaczenie: szulcu
* Poprawki: Ekipa Polskiego Supportu MyBB (mybboard.pl)
* Wersja 1.0 
**/ 

if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$plugins->add_hook("forumdisplay_thread","thread_description_format_description");
$plugins->add_hook("search_results_thread","thread_description_format_description");
$plugins->add_hook("showthread_start","thread_description_format_description");

$plugins->add_hook("newthread_start","thread_description_language");

$plugins->add_hook("usercp_drafts_end","thread_description_showdrafts");

$plugins->add_hook("newthread_start","thread_description_preview_draft");
$plugins->add_hook("newthread_do_newthread_end", "thread_description_do_newthread");

$plugins->add_hook("editpost_end", "thread_description_editpost");
$plugins->add_hook("editpost_do_editpost_end", "thread_description_do_editpost");


function thread_description_info()
{
	global	$lang, $db;
	$lang->load("thread_description",true);

	$info = array(
		"name"			=> "Thread Description",
		"description"	=> $lang->thread_description_desc,
        "website"		=> "http://mods.mybboard.net/",
        "author"		=> "kastun",
        "authorsite"	=> "http://ecu.bplaced.net",
        "version"		=> "1.1",
		"guid"			=> "11b63e07e109a60fb491b1c98ba0cbf0",
		"compatibility"	=> "14*"
	);

	// Shows warning if plugin is installed
	if(thread_description_is_installed())
	{
		$info['description'].=" <b>".$lang->thread_description_desc_warning."</b>";
	}

	return $info;
}
 
function thread_description_install()
{
	global	$db;

	// Creates column for description	
	if(!$db->field_exists('description', "threads"))
	{
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."threads ADD description VARCHAR (140) NOT NULL AFTER subject");
	}	

	// Inserts edit first post template	
	$insert_array = array(
		'title'		=> 'editpost_first_post',
		'template'	=> $db->escape_string("<tr>\n	<td class=\"trow1\"><strong>{\$lang->thread_description_edit}</strong></td>\n	<td class=\"trow1\"><input type=\"text\" class=\"textbox\" name=\"description\" size=\"40\" maxlength=\"140\" value=\"{\$thread['description']}\" tabindex=\"1\" /></td>\n</tr>"),
		'sid'		=> '-1',
		'version'	=> '',
		'dateline'	=> TIME_NOW
	);
	
	$db->insert_query("templates", $insert_array);
}

function thread_description_is_installed()
{
	global	$db;
	
	return $db->field_exists('description', "threads");
}

function thread_description_activate()
{
	require MYBB_ROOT."/inc/adminfunctions_templates.php";
	
	// Modifies templates
	find_replace_templatesets("forumdisplay_thread", "#".preg_quote('<div class="author smalltext">{$thread[\'profilelink\']}</div>')."#i", '<span class="author smalltext">{$lang->by} {$thread[\'profilelink\']}</span><br />{$thread[\'description\']}');
	find_replace_templatesets("search_results_threads_thread", "#".preg_quote('<div class="author smalltext">{$thread[\'profilelink\']}</div>')."#i", '<span class="author smalltext">{$lang->by} {$thread[\'profilelink\']}</span><br />{$thread[\'description\']}');
	find_replace_templatesets("showthread", "#".preg_quote('{$thread[\'subject\']}</strong>')."#i", '{$thread[\'subject\']}</strong><br />{$thread[\'description\']}');
	find_replace_templatesets("newthread", "#".preg_quote('{$posticons}')."#i", '<tr><td class="trow1" width="20%"><strong>{$lang->thread_description_edit}</strong></td><td class="trow1"><input type="text" class="textbox" name="description" size="40" maxlength="140" value="{$description}" tabindex="1" /></td></tr>{$posticons}');
	find_replace_templatesets("editpost", "#".preg_quote('{$posticons}')."#i", '{$thread_description_first_post}{$posticons}');
	find_replace_templatesets("usercp_drafts_draft", "#".preg_quote('<strong>{$draft[\'subject\']}</strong><br />')."#i", '<strong>{$draft[\'subject\']}</strong><br />{$thread_description}');

}

function thread_description_deactivate()
{
	require MYBB_ROOT."/inc/adminfunctions_templates.php";

	// Resets templates
	find_replace_templatesets("forumdisplay_thread", "#".preg_quote('<span class="author smalltext">{$lang->by} {$thread[\'profilelink\']}</span><br />{$thread[\'description\']}')."#i", '<div class="author smalltext">{$thread[\'profilelink\']}</div>', 0);
	find_replace_templatesets("search_results_threads_thread", "#".preg_quote('<span class="author smalltext">{$lang->by} {$thread[\'profilelink\']}</span><br />{$thread[\'description\']}')."#i", '<div class="author smalltext">{$thread[\'profilelink\']}</div>', 0);
	find_replace_templatesets("showthread", "#".preg_quote('<br />{$thread[\'description\']}')."#i", '', 0);
	find_replace_templatesets("newthread", "#".preg_quote('<tr><td class="trow1" width="20%"><strong>{$lang->thread_description_edit}</strong></td><td class="trow1"><input type="text" class="textbox" name="description" size="40" maxlength="140" value="{$description}" tabindex="1" /></td></tr>')."#i", '', 0);
	find_replace_templatesets("editpost", "#".preg_quote('{$thread_description_first_post}')."#i", '', 0);
	find_replace_templatesets("usercp_drafts_draft", "#".preg_quote('{$thread_description}')."#i", '', 0);
}

function thread_description_uninstall()
{
	global	$db;
	
	if($db->field_exists('description', "threads"))
	{
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."threads DROP description"); 
	}

	$db->delete_query("templates", "title = 'editpost_first_post'");
}





function thread_description_language()
{
	global	$lang;

	$lang->load("thread_description");
}

function thread_description_format_description()
{
	global	$thread;

	if(trim($thread['description']) != "")
	{
		$thread['description']='<span class="smalltext">&raquo; '.htmlspecialchars_uni($thread['description']).'</span>';
	}
}

function thread_description_showdrafts()
{
	global	$db, $mybb, $lang,  
			$templates, $theme, $header, $headerinclude, $usercpnav, $footer,
			$draftlist;

	// Mainly copy & paste from usercp.php, made some adjustments for draft threads to show the description there
	$drafts = '';
	$query = $db->query("
		SELECT p.subject, p.pid, t.tid, t.subject AS threadsubject, t.description AS threaddescription, t.fid, f.name AS forumname, p.dateline, t.visible AS threadvisible, p.visible AS postvisible
		FROM ".TABLE_PREFIX."posts p
		LEFT JOIN ".TABLE_PREFIX."threads t ON (t.tid=p.tid)
		LEFT JOIN ".TABLE_PREFIX."forums f ON (f.fid=t.fid)
		WHERE p.uid='".$mybb->user['uid']."' AND p.visible='-2'
		ORDER BY p.dateline DESC
	");
	while($draft = $db->fetch_array($query))
	{
		$trow = alt_trow();
		$thread_description = "";
		if($draft['threadvisible'] == 1) // We're looking at a draft post
		{
			$detail = $lang->thread." <a href=\"".get_thread_link($draft['tid'])."\">".htmlspecialchars_uni($draft['threadsubject'])."</a>";
			$editurl = "newreply.php?action=editdraft&amp;pid={$draft['pid']}";
			$id = $draft['pid'];
			$type = "post";
		}
		elseif($draft['threadvisible'] == -2) // We're looking at a draft thread
		{
			$detail = $lang->forum." <a href=\"".get_forum_link($draft['fid'])."\">".htmlspecialchars_uni($draft['forumname'])."</a>";
			$editurl = "newthread.php?action=editdraft&amp;tid={$draft['tid']}";
			$id = $draft['tid'];
			$type = "thread";
			if(trim($draft['threaddescription']) != "")
			{
				$thread_description = "<span class=\"smalltext\">&raquo; ".htmlspecialchars_uni($draft['threaddescription'])."</span><br />";
			}
		}
		$draft['subject'] = htmlspecialchars_uni($draft['subject']);
		$savedate = my_date($mybb->settings['dateformat'], $draft['dateline']);
		$savetime = my_date($mybb->settings['timeformat'], $draft['dateline']);
		eval("\$drafts .= \"".$templates->get("usercp_drafts_draft")."\";");
	}
	if(!$drafts)
	{
		eval("\$drafts = \"".$templates->get("usercp_drafts_none")."\";");
	}
	else
	{
		eval("\$draftsubmit = \"".$templates->get("usercp_drafts_submit")."\";");
	}
	eval("\$draftlist = \"".$templates->get("usercp_drafts")."\";");
}

function thread_description_preview_draft()
{
	global	$mybb, $db, $post, 
			$description, $message;

	if($mybb->input['action'] == "editdraft")
	{
		$query=$db->simple_select("threads", "description", "tid='".$post['tid']."'");
		$thread=$db->fetch_array($query);

		$description=htmlspecialchars_uni($thread['description']);
	}
	else
	{
		$description=htmlspecialchars_uni($mybb->input['description']);
	}
}

function thread_description_do_newthread()
{
	global $mybb, $db, $thread_info;

	$db->update_query("threads", array("description" => my_wordwrap($db->escape_string($mybb->input['description']))), "tid='".$thread_info['tid']."'");
}

function thread_description_editpost()
{
	global	$mybb, $db, $pid, $lang,
			$templates, $post_errors,
			$thread_description_first_post;

	$lang->load("thread_description");

	// Is it the first post of the thread?
	$query=$db->query("	SELECT p.tid, t.firstpost, t.description 
						FROM ".TABLE_PREFIX."posts p, ".TABLE_PREFIX."threads t 
						WHERE p.pid='".$pid."' AND t.tid=p.tid");
	$control=$db->fetch_array($query);

	if($control['firstpost'] == $pid)
	{
		// Simple edit or preview?
		if($mybb->input['previewpost'] || $post_errors)
		{
			$thread['description']=$mybb->input['description'];
		}
		else
		{
			$thread['description']=$control['description'];
		}

		$thread['description']=htmlspecialchars_uni($thread['description']);

		eval("\$thread_description_first_post = \"".$templates->get("editpost_first_post")."\";");
	}
}

function thread_description_do_editpost()
{
	global $db, $mybb, $tid, $pid;

	$query=$db->simple_select("posts", "pid", "tid='".$tid."'", array("limit" => 1, "order_by" => "dateline", "order_dir" => "asc"));
	$control=$db->fetch_array($query);

	if($control['pid'] == $pid)
	{
		$db->update_query("threads", array(	"description" => my_wordwrap($db->escape_string($mybb->input['description']))), "tid='".$tid."'");
	}
}

?>